P365/urls.py
from django.conf import settings
from django.conf.urls.static import static
from django.urls import include, path
from django.contrib import admin
from django.contrib.auth.views import logout_then_login

import calendar_year.urls
import profile.urls
import story.urls
import table.urls
import tag.urls
from map import urls_map, urls_poi, urls_route, urls_track
from profile.views import LoginView, ProfileRedirect, SignUpView, IndexView

urlpatterns = [
    # main
    path('',            IndexView.as_view(),        name='index'),
    path('admin/',      admin.site.urls,),
    path('summernote/', include('django_summernote.urls')),
    # auth
    path('login/',      LoginView.as_view(),        name='login'),
    path('register/',   SignUpView.as_view(),       name='signup'),
    path('logout/',     logout_then_login,          name='logout'),
    # redirection
    path('accounts/profile/', ProfileRedirect.as_view()),
    # tabs
    path('calendar/',   include(calendar_year.urls, namespace='calendar')),
    path('map/',        include(urls_map,           namespace='map')),
    path('table/',      include(table.urls,         namespace='table')),
    path('story/',      include(story.urls,         namespace='story')),
    # other
    path('user/',       include(profile.urls,       namespace='user')),
    path('poi/',        include(urls_poi,           namespace='poi')),
    path('route/',      include(urls_route,         namespace='route')),
    path('track/',      include(urls_track,         namespace='track')),
    path('tag/',        include(tag.urls,           namespace='tag')),
]

if settings.DEBUG:
    urlpatterns += static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)

calendar_year/urls.py
from django.urls import path, register_converter

from P365.converters import UintWithoutZero
from .views import CalendarView, DatesEventView, GetAllEventsView, DeleteEventView, UpdateCreateEventView

app_name = 'calendar'

register_converter(UintWithoutZero, 'uint_id')

urlpatterns = [
    path('',                        CalendarView.as_view(),             name='view'),
    path('<uint_id:id>/dates_get/', DatesEventView.as_view(),           name='dates_event'),
    path('get_all_events/',         GetAllEventsView.as_view(),         name='get_all_events'),
    path('delete_event/',           DeleteEventView.as_view(),          name='delete_event'),
    path('update_or_create_event/', UpdateCreateEventView.as_view(),    name='update_event'),
]

profile/urls.py
from django.urls import path

from table.views import TableView
from .views import ProfileView

app_name = 'user'

urlpatterns = [
    path('<slug:username>/',        ProfileView.as_view(),  name='profile'),
    path('<slug:username>/table/',  TableView.as_view(),    name='table')
]

story/urls.py
from django.urls import path, register_converter

from P365.converters import UintWithoutZero
from .views import StoriesView, StoryView, StoryEditView, JSONStoryDeleteView

app_name = 'story'

register_converter(UintWithoutZero, 'uint_id')

urlpatterns = [
    path('',                          StoriesView.as_view(),         name='stories'),
    path('<uint_id:id>/',             StoryView.as_view(),           name='view'),
    path('<uint_id:id>/edit/',        StoryEditView.as_view(),       name='edit'),
    path('<uint_id:id>/json_delete/', JSONStoryDeleteView.as_view(), name='json_delete'),
    path('create/',                   StoryEditView.as_view(),       name='create'),
]

tag/urls.py
from django.urls import path

from .views import TagCloudView, TagView

app_name = 'tag'

urlpatterns = [
    path('',                TagCloudView.as_view(), name='tag_cloud'),
    path('<slug:tagslug>/', TagView.as_view(),      name='tag'),
]

story/models.py
from django.contrib.auth.models import User
from django.db import models
from taggit.managers import TaggableManager

from P365.settings import MAX_LENGTH
from calendar_year.models import EventModel
from map.models import TrackModel


class StoryModel(models.Model):
    title = models.CharField(max_length=MAX_LENGTH['title'])
    text = models.TextField(max_length=MAX_LENGTH['text'])
    track = models.ForeignKey(TrackModel, on_delete=models.CASCADE, null=True, blank=True)
    event = models.ForeignKey(EventModel, on_delete=models.CASCADE)
    created = models.DateTimeField(auto_now_add=True)
    tags = TaggableManager(blank=True)
    user = models.ForeignKey(User, on_delete=models.CASCADE)
    is_active = models.BooleanField(default=True)

    objects = models.Manager()

    def __str__(self):
        return self.title

story/forms.py
from django.forms import ModelForm
from django_summernote.widgets import SummernoteWidget

from calendar_year.models import EventModel
from map.models import TrackModel
from .models import StoryModel


class StoryForm(ModelForm):
    class Meta:
        model = StoryModel
        exclude = ('user', 'is_active')
        widgets = {
            'text': SummernoteWidget(),
        }

    def __init__(self, user, *args, **kwargs):
        super().__init__(*args, **kwargs)
        if user:
            self.fields['track'].queryset = TrackModel.objects.filter(user=user, is_active=True)
            self.fields['event'].queryset = EventModel.objects.filter(user=user, is_active=True)

    def clean(self):
        # Bad way to fix one-to-one field without changing error. FIXME!
        return self.cleaned_data

story/views.py
from django.contrib.auth.decorators import login_required
from django.http import HttpResponseForbidden, HttpResponseRedirect, JsonResponse
from django.shortcuts import render, get_object_or_404
from django.urls import reverse
from django.utils.decorators import method_decorator
from django.views import View

from profile.models import ProfileModel
from story.forms import StoryForm
from story.models import StoryModel


@method_decorator(login_required, name='dispatch')
class StoriesView(View):
    @staticmethod
    def get(request, username=None):
        if not username or username == request.user:
            profile = get_object_or_404(ProfileModel, user=request.user)
        else:
            profile = get_object_or_404(ProfileModel, user__username=username)
        stories = StoryModel.objects.filter(user=request.user, is_active=True).order_by('-event__start_date')
        return render(request, 'stories.html', {
            'title': 'Stories',
            'active': 'stories',
            'profile': profile,
            'stories': stories
        })


@method_decorator(login_required, name='dispatch')
class StoryView(View):
    @staticmethod
    def get(request, id):
        story = get_object_or_404(StoryModel, id=id)
        if (story.user == story.user or story.public) and story.is_active:
            return render(request, 'story-viewer.html', {'title': story.title, 'story': story})
        return HttpResponseForbidden()


@method_decorator(login_required, name='dispatch')
class StoryEditView(View):
    @staticmethod
    def get(request, id=None):
        story = get_object_or_404(StoryModel, id=id) if id else None
        if story and story.user != request.user and story.is_active:
            return HttpResponseForbidden()
        form = StoryForm(request.user, instance=story)
        return render(request, 'story-editor.html', {'title': story.title if story else 'New story', 'form': form})

    @staticmethod
    def post(request, id=None):
        form = StoryForm(request.user, request.POST)
        if form.is_valid():
            if id:
                story = get_object_or_404(StoryModel, id=id)
                story.title = form.cleaned_data['title']
                story.text = form.cleaned_data['text']
                story.track = form.cleaned_data['track']
                story.event = form.cleaned_data['event']
                story.tags.set(*form.cleaned_data['tags'])
            else:
                story = form.save(commit=False)
                story.user = request.user
            story.save()
            form.save_m2m() if not id else None
            return HttpResponseRedirect(reverse('story:stories'))
        return render(request, 'story-editor.html', {'title': form['title'].value(), 'form': form})


@method_decorator(login_required, name='dispatch')
class JSONStoryDeleteView(View):
    @staticmethod
    def post(request, id):
        story = get_object_or_404(StoryModel, id=id)
        if story.user == request.user and story.is_active:
            story.is_active = False
            story.save()
            return JsonResponse({'Status': 'OK'})
        return HttpResponseForbidden()

story/templates/stories.html
{% extends "base/base.html" %}
{% load staticfiles %}
{% load leaflet_tags %}

{% block content %}
{% csrf_token %}
{% if stories %}
<div class="row">
    <div class="col">
        <a href="{% url 'story:create' %}">
            <button class="btn btn-success float-right">
                <i class="fas fa-plus" aria-hidden="true"></i> New story
            </button>
        </a>
    </div>
</div>
<div class="row">
    {% for story in stories %}
    <div class="card-group col-sm-12 col-md-6 col-xl-4">
        <div class="card text-white bg-dark" id="story-{{ story.id }}" onclick='location.href="{% url "story:view" story.id %}"' style="cursor:pointer">
            <div class="card-img-top">
                {% with story.id|stringformat:"s" as story_id and story.track.id|stringformat:"s"|default:"0" as track_id %}
                {% with "map-"|add:story_id|add:"_"|add:track_id as map_id %}
                {% leaflet_map map_id callback="window.map_init_basic" %}
                {% endwith %}
                {% endwith %}
            </div>
            <div class="card-body">
                <h5 class="card-title">
                    {{ story.title }}
                    <span class="float-right"><a href="#" class="btn btn-default btn-delete" role="button"><i class="fa fa-trash"></i></a></span>
                    <span class="float-right"><a href="{% url 'story:edit' story.id %}" class="btn btn-default" role="button"><i class="fas fa-edit"></i></a></span>
                </h5>
                <p class="card-text">
                    {{ story.text|truncatewords_html:20|safe }}
                </p>
            </div>
            <div class="card-footer text-center">
                <small class="text-muted">{{ story.event.start_date|date }} - {{ story.event.finish_date|date }}</small>
            </div>
        </div>
    </div>
    {% empty %}
    <div class="alert alert-info" role="alert">
        You don't have Stories yet. Try to <a href="{% url 'story:create' %}" class="alert-link">create your first Story</a>.
    </div>
    {% endfor %}
</div>
{% endif %}
{% endblock %}

{% block css %}
    {% leaflet_css %}
    <link href="{% static 'css/stories.css' %}" rel="stylesheet" media="screen">
{% endblock %}

{% block js %}
    {% leaflet_js %}
    <script>
        var url_story_delete = "{% url 'story:json_delete' 0 %}",
            url_track_json = "{% url 'track:json' 0 %}";
    </script>
    <script src="{% static 'js/stories.js' %}"></script>
{% endblock %}

story/templates/story-editor.html
{% extends "base/base.html" %}
{% load bootstrap4 %}
{% load leaflet_tags %}
{% load staticfiles %}

{% block content %}
<form method="post" action="" class="form">
    {% csrf_token %}
    <div class="row">
        <div class="col-md-6" id="map">
            {% bootstrap_field form.track show_label=False %}
            {% leaflet_map "mainmap" callback="window.map_init_basic" %}
        </div>
        <div class="col-md-6" id="other">
            {% bootstrap_form_errors form %}
            {% bootstrap_field form.title show_label=False %}
            <div class="row">
                <div class="col-sm-6">
                    {% bootstrap_field form.event show_label=False %}
                </div>
                <div class="col-sm-6 text-center" id="event-dates"></div>
            </div>
            {{ form.text }}
            {% bootstrap_field form.tags show_label=False %}
            <div class="col-12 form-group text-center">
                {% bootstrap_button 'Save' button_type='submit' button_class='btn-success' %}
            </div>
        </div>
    </div>
</form>
{% endblock %}

{% block css %}
    {% leaflet_css %}
    <link href="{% static 'css/story-editor.css' %}" rel="stylesheet" media="screen">
{% endblock %}

{% block js %}
    {% leaflet_js %}
    <script>
        var url_track_json = "{% url 'track:json' 0 %}",
            url_calendar_dates = "{% url 'calendar:dates_event' 0 %}";
    </script>
    <script src="{% static 'js/story-editor.js' %}"></script>
{% endblock %}

story/templates/story-viewer.html
{% extends "base/base.html" %}
{% load staticfiles %}
{% load leaflet_tags %}

{% block content %}
<div class="row">
    <div class="col-6">
        {% leaflet_map "mainmap" callback="window.map_init_basic" %}
    </div>
    <div class="col-6">
        <div id="title" class="text-center">
            <h3>{{ story.title }}</h3>
            <small>by <a href="{% url 'user:profile' story.user %}">{{ story.user }}</a></small>
            <p><b>{{ story.event.start_date|date }} - {{ story.event.finish_date|date }}</b></p>
        </div>
        <div id="text">{{ story.text|safe }}</div>
    </div>
</div>
{% endblock %}

{% block css %}
    {% leaflet_css plugins='elevation' %}
    <link href="{% static 'css/story-viewer.css' %}" rel="stylesheet" media="screen">
{% endblock %}

{% block js %}
    {% leaflet_js plugins='elevation' %}
    <script>
        var track_id = {{ story.track.id|default:0 }};
        var url_track_json = "{% url 'track:json' story.track.id|default:0 %}";
    </script>
    <script src="{% static 'js/story-viewer.js' %}"></script>
{% endblock %}